# hwloc packaging for RHEL; probably needs fixing for SuSE.
# Copyright (c) 2012  Dave Love, University of Liverpool
# Licence as for hwloc

Name:           hwloc
Version:        1.6
Release:        1%{?dist}
Summary:        Portable Hardware Locality: hierarchical view of the machine

Group:          System Environment/Libraries
License:        BSD
URL:            http://www.open-mpi.org/projects/hwloc/
Source0:        http://www.open-mpi.org/software/hwloc/v%{version}/downloads/%{name}-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# NB no CUDA
BuildRequires:  pciutils-devel, ncurses-devel, cairo-devel, libxml2-devel, libibverbs-devel
# fixme: check RPM arches c.f. dpkg
%ifarch x86_64 i386 ia64 mips mipsel powerpc
BuildRequires:  numactl-devel
%endif

%description
Hardware Locality (hwloc) provides a portable abstraction (across OS, versions,
architectures, ...) of the hierarchical topology of modern architectures. It
primarily aims at helping high-performance computing applications with
gathering information about the hardware so as to exploit it accordingly and
efficiently. 

hwloc provides a hierarchical view of the machine, NUMA memory nodes, sockets,
shared caches, cores and simultaneous multithreading. It also gathers various
attributes such as cache and memory information. 

hwloc supports old kernels not having sysfs topology information, with
knowledge of cpusets, offline cpus, and Kerrighed support.

%package        devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package	utils
Summary:	Command line tools for %{name}
Group:		Applications/System
Conflicts:	%{name}-nox

%description	utils
The hwloc-utils package contains utilities to show the topology of the
machine, manipulate cpu masks, and bind processes.

%package	utils-nox
Summary:	Command line tools for %{name} without X dependence
Group:		Applications/System
Conflicts:	%{name}

%description	utils-nox
The hwloc-utils-nox package contains utilities to show the topology of the
machine, manipulate cpu masks, and bind processes, without any dependence
on X libraries.

%prep
%setup -q

%build
%configure --enable-static
make %{?_smp_mflags} V=1

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'
# no CUDA
rm $RPM_BUILD_ROOT%{_mandir}/man3/*cuda*

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post utils-nox
ln -s /usr/bin/lstopo-no-graphics /usr/bin/lstopo
ln -s /usr/bin/lstopo-no-graphics /usr/bin/hwloc-info
ln -s /usr/bin/lstopo-no-graphics /usr/bin/hwloc-ps

%post utils
ln -s /usr/bin/lstopo /usr/bin/hwloc-info
ln -s /usr/bin/lstopo /usr/bin/hwloc-ps

%postun utils-nox
rm -f /usr/bin/lstopo
rm -f /usr/bin/hwloc-info
rm -f /usr/bin/hwloc-ps

%postun utils
rm -f /usr/bin/hwloc-info
rm -f /usr/bin/hwloc-ps

%files
%defattr(-,root,root,-)
%doc COPYING NEWS README
%doc %_docdir/%{name}/*.pdf
%{_libdir}/*.so.*
%{_datadir}/*

%files devel
%defattr(-,root,root,-)
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/*.a
%{_mandir}/man3/*
%{_libdir}/pkgconfig/*

%files utils
%defattr(-,root,root,-)
%{_bindir}/lstopo
%{_bindir}/hwloc-*
%{_mandir}/man1/*
%{_mandir}/man7/*
%doc COPYING NEWS README

%files utils-nox
%defattr(-,root,root,-)
%{_bindir}/lstopo-no-graphics
%{_bindir}/hwloc-*
%{_mandir}/man1/*
%{_mandir}/man7/*
%doc COPYING NEWS README

%changelog
* Fri Dec 14 2012 Dave Love <d.love@liverool.ac.uk> - 1.6-1
- Initial packaging, following Debian's and distinct from Fedora's
